#include "linkage.h"

        .h8300h
        .file "entry.S"

        .section .text
        .align 2
        .global _start

ASTCR = 0xfee021
P1DDR = 0xfee000
P2DDR = 0xfee001
P5DDR = 0xfee004
P8DDR = 0xfee007
IPRB = 0xfee019

;----------------------------------------------------------------------------
ENTRY(start)
;
/* Initialize Stack Pointer */

        mov.l	#SYMBOL_NAME(stub_stack), er7
        
/* HW Initialize */

; SRAM(0x200000-0x3fffff) 2 state access
		mov.b	#0xfd, r0l
        mov.b	r0l, @ASTCR
	
; P1 is address bus(A0-7)
		mov.b	#0xff, r0l
        mov.b	r0l, @P1DDR
        
; P2 is address bus(A8-15)
		mov.b	#0xff, r0l
        mov.b	r0l, @P2DDR
        
; P5 is Address bus(A16-18)
		mov.b	#0xf7, r0l
        mov.b	r0l, @P5DDR
        
; CS1 output
		mov.b	#0xe8, r0l
        mov.b	r0l, @P8DDR

; SCI0 Interrupt is High Level Priority
		mov.b	#0x08, r0l
        mov.b	r0l, @IPRB

; Initialize Serial Port
        jsr		SYMBOL_NAME(init_serial)

/* Initialize BSS */

        mov.l	#__bss_start, er0
        mov.l	#__bss_end, er1
        sub.l	er2, er2
L1:
        mov.l	er2, @er0
        add.l	#4, er0
        cmp.l	er1, er0
        blo		L1
        
/* Initialize Data */

        mov.l	#__idata_start, er0
        mov.l	#__idata_end, er1
        mov.l	#__data_start, er2
L2:
        mov.l	@er0+, er4
        mov.l	er4, @er2
        add.l	#4, er2
        cmp.l	er1, er0
        blo		L2

/* Jump to GDB_STUB */

        jmp		SYMBOL_NAME(start_gdbstub)
